//#line 2 "/opt/ros/electric/stacks/driver_common/dynamic_reconfigure/templates/ConfigType.h"
// *********************************************************
// 
// File autogenerated for the gazebo package 
// by the dynamic_reconfigure package.
// Please do not edit.
// 
// ********************************************************/

/***********************************************************
 * Software License Agreement (BSD License)
 *
 *  Copyright (c) 2008, Willow Garage, Inc.
 *  All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions
 *  are met:
 *
 *   * Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 *   * Redistributions in binary form must reproduce the above
 *     copyright notice, this list of conditions and the following
 *     disclaimer in the documentation and/or other materials provided
 *     with the distribution.
 *   * Neither the name of the Willow Garage nor the names of its
 *     contributors may be used to endorse or promote products derived
 *     from this software without specific prior written permission.
 *
 *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 *  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 *  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 *  FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 *  COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 *  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 *  BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 *  LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 *  CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 *  LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 *  ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 *  POSSIBILITY OF SUCH DAMAGE.
 ***********************************************************/

// Author: Blaise Gassend


#ifndef __gazebo__PHYSICSCONFIG_H__
#define __gazebo__PHYSICSCONFIG_H__

#include <dynamic_reconfigure/config_tools.h>
#include <limits>
#include <ros/node_handle.h>
#include <dynamic_reconfigure/ConfigDescription.h>
#include <dynamic_reconfigure/ParamDescription.h>
#include <dynamic_reconfigure/config_init_mutex.h>

namespace gazebo
{
  class PhysicsConfigStatics;
  
  class PhysicsConfig
  {
  public:
    class AbstractParamDescription : public dynamic_reconfigure::ParamDescription
    {
    public:
      AbstractParamDescription(std::string n, std::string t, uint32_t l, 
          std::string d, std::string e)
      {
        name = n;
        type = t;
        level = l;
        description = d;
        edit_method = e;
      }
      
      virtual void clamp(PhysicsConfig &config, const PhysicsConfig &max, const PhysicsConfig &min) const = 0;
      virtual void calcLevel(uint32_t &level, const PhysicsConfig &config1, const PhysicsConfig &config2) const = 0;
      virtual void fromServer(const ros::NodeHandle &nh, PhysicsConfig &config) const = 0;
      virtual void toServer(const ros::NodeHandle &nh, const PhysicsConfig &config) const = 0;
      virtual bool fromMessage(const dynamic_reconfigure::Config &msg, PhysicsConfig &config) const = 0;
      virtual void toMessage(dynamic_reconfigure::Config &msg, const PhysicsConfig &config) const = 0;
    };

    typedef boost::shared_ptr<AbstractParamDescription> AbstractParamDescriptionPtr;
    typedef boost::shared_ptr<const AbstractParamDescription> AbstractParamDescriptionConstPtr;
    
    template <class T>
    class ParamDescription : public AbstractParamDescription
    {
    public:
      ParamDescription(std::string name, std::string type, uint32_t level, 
          std::string description, std::string edit_method, T PhysicsConfig::* f) :
        AbstractParamDescription(name, type, level, description, edit_method),
        field(f)
      {}

      T (PhysicsConfig::* field);

      virtual void clamp(PhysicsConfig &config, const PhysicsConfig &max, const PhysicsConfig &min) const
      {
        if (config.*field > max.*field)
          config.*field = max.*field;
        
        if (config.*field < min.*field)
          config.*field = min.*field;
      }

      virtual void calcLevel(uint32_t &comb_level, const PhysicsConfig &config1, const PhysicsConfig &config2) const
      {
        if (config1.*field != config2.*field)
          comb_level |= level;
      }

      virtual void fromServer(const ros::NodeHandle &nh, PhysicsConfig &config) const
      {
        nh.getParam(name, config.*field);
      }

      virtual void toServer(const ros::NodeHandle &nh, const PhysicsConfig &config) const
      {
        nh.setParam(name, config.*field);
      }

      virtual bool fromMessage(const dynamic_reconfigure::Config &msg, PhysicsConfig &config) const
      {
        return dynamic_reconfigure::ConfigTools::getParameter(msg, name, config.*field);
      }

      virtual void toMessage(dynamic_reconfigure::Config &msg, const PhysicsConfig &config) const
      {
        dynamic_reconfigure::ConfigTools::appendParameter(msg, name, config.*field);
      }
    };

//#line 44 "../cfg/Physics.cfg"
      double time_step;
//#line 45 "../cfg/Physics.cfg"
      double max_update_rate;
//#line 46 "../cfg/Physics.cfg"
      double gravity_x;
//#line 47 "../cfg/Physics.cfg"
      double gravity_y;
//#line 48 "../cfg/Physics.cfg"
      double gravity_z;
//#line 49 "../cfg/Physics.cfg"
      bool auto_disable_bodies;
//#line 50 "../cfg/Physics.cfg"
      int sor_pgs_precon_iters;
//#line 51 "../cfg/Physics.cfg"
      int sor_pgs_iters;
//#line 52 "../cfg/Physics.cfg"
      double sor_pgs_w;
//#line 53 "../cfg/Physics.cfg"
      double sor_pgs_rms_error_tol;
//#line 54 "../cfg/Physics.cfg"
      double cfm;
//#line 55 "../cfg/Physics.cfg"
      double erp;
//#line 56 "../cfg/Physics.cfg"
      double contact_surface_layer;
//#line 57 "../cfg/Physics.cfg"
      double contact_max_correcting_vel;
//#line 58 "../cfg/Physics.cfg"
      int max_contacts;
//#line 138 "/opt/ros/electric/stacks/driver_common/dynamic_reconfigure/templates/ConfigType.h"

    bool __fromMessage__(dynamic_reconfigure::Config &msg)
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      int count = 0;
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        if ((*i)->fromMessage(msg, *this))
          count++;
      if (count != dynamic_reconfigure::ConfigTools::size(msg))
      {
        ROS_ERROR("PhysicsConfig::__fromMessage__ called with an unexpected parameter.");
        ROS_ERROR("Booleans:");
        for (unsigned int i = 0; i < msg.bools.size(); i++)
          ROS_ERROR("  %s", msg.bools[i].name.c_str());
        ROS_ERROR("Integers:");
        for (unsigned int i = 0; i < msg.ints.size(); i++)
          ROS_ERROR("  %s", msg.ints[i].name.c_str());
        ROS_ERROR("Doubles:");
        for (unsigned int i = 0; i < msg.doubles.size(); i++)
          ROS_ERROR("  %s", msg.doubles[i].name.c_str());
        ROS_ERROR("Strings:");
        for (unsigned int i = 0; i < msg.strs.size(); i++)
          ROS_ERROR("  %s", msg.strs[i].name.c_str());
        // @todo Check that there are no duplicates. Make this error more
        // explicit.
        return false;
      }
      return true;
    }

    // This version of __toMessage__ is used during initialization of
    // statics when __getParamDescriptions__ can't be called yet.
    void __toMessage__(dynamic_reconfigure::Config &msg, const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__) const
    {
      dynamic_reconfigure::ConfigTools::clear(msg);
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        (*i)->toMessage(msg, *this);
    }
    
    void __toMessage__(dynamic_reconfigure::Config &msg) const
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      __toMessage__(msg, __param_descriptions__);
    }
    
    void __toServer__(const ros::NodeHandle &nh) const
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        (*i)->toServer(nh, *this);
    }

    void __fromServer__(const ros::NodeHandle &nh)
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        (*i)->fromServer(nh, *this);
    }

    void __clamp__()
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      const PhysicsConfig &__max__ = __getMax__();
      const PhysicsConfig &__min__ = __getMin__();
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        (*i)->clamp(*this, __max__, __min__);
    }

    uint32_t __level__(const PhysicsConfig &config) const
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      uint32_t level = 0;
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        (*i)->calcLevel(level, config, *this);
      return level;
    }
    
    static const dynamic_reconfigure::ConfigDescription &__getDescriptionMessage__();
    static const PhysicsConfig &__getDefault__();
    static const PhysicsConfig &__getMax__();
    static const PhysicsConfig &__getMin__();
    static const std::vector<AbstractParamDescriptionConstPtr> &__getParamDescriptions__();
    
  private:
    static const PhysicsConfigStatics *__get_statics__();
  };
  
  template <> // Max and min are ignored for strings.
  inline void PhysicsConfig::ParamDescription<std::string>::clamp(PhysicsConfig &config, const PhysicsConfig &max, const PhysicsConfig &min) const
  {
    return;
  }

  class PhysicsConfigStatics
  {
    friend class PhysicsConfig;
    
    PhysicsConfigStatics()
    {
//#line 44 "../cfg/Physics.cfg"
      __min__.time_step = 0.0;
//#line 44 "../cfg/Physics.cfg"
      __max__.time_step = 10.0;
//#line 44 "../cfg/Physics.cfg"
      __default__.time_step = 0.001;
//#line 44 "../cfg/Physics.cfg"
      __param_descriptions__.push_back(PhysicsConfig::AbstractParamDescriptionConstPtr(new PhysicsConfig::ParamDescription<double>("time_step", "double", 1, "Simulation world time step size in seconds, smaller time steps producesslower, more stable simulation.", "", &PhysicsConfig::time_step)));
//#line 45 "../cfg/Physics.cfg"
      __min__.max_update_rate = 0.0;
//#line 45 "../cfg/Physics.cfg"
      __max__.max_update_rate = 1000.0;
//#line 45 "../cfg/Physics.cfg"
      __default__.max_update_rate = 60.0;
//#line 45 "../cfg/Physics.cfg"
      __param_descriptions__.push_back(PhysicsConfig::AbstractParamDescriptionConstPtr(new PhysicsConfig::ParamDescription<double>("max_update_rate", "double", 1, "Simulator max update rate, -1 unlimited, 1 restricts to real-time if possible.", "", &PhysicsConfig::max_update_rate)));
//#line 46 "../cfg/Physics.cfg"
      __min__.gravity_x = -100.0;
//#line 46 "../cfg/Physics.cfg"
      __max__.gravity_x = 100.0;
//#line 46 "../cfg/Physics.cfg"
      __default__.gravity_x = 0.0;
//#line 46 "../cfg/Physics.cfg"
      __param_descriptions__.push_back(PhysicsConfig::AbstractParamDescriptionConstPtr(new PhysicsConfig::ParamDescription<double>("gravity_x", "double", 1, "Simulated gravity in the x direction.", "", &PhysicsConfig::gravity_x)));
//#line 47 "../cfg/Physics.cfg"
      __min__.gravity_y = -100.0;
//#line 47 "../cfg/Physics.cfg"
      __max__.gravity_y = 100.0;
//#line 47 "../cfg/Physics.cfg"
      __default__.gravity_y = 0.0;
//#line 47 "../cfg/Physics.cfg"
      __param_descriptions__.push_back(PhysicsConfig::AbstractParamDescriptionConstPtr(new PhysicsConfig::ParamDescription<double>("gravity_y", "double", 1, "Simulated gravity in the y direction.", "", &PhysicsConfig::gravity_y)));
//#line 48 "../cfg/Physics.cfg"
      __min__.gravity_z = -100.0;
//#line 48 "../cfg/Physics.cfg"
      __max__.gravity_z = 100.0;
//#line 48 "../cfg/Physics.cfg"
      __default__.gravity_z = -9.8;
//#line 48 "../cfg/Physics.cfg"
      __param_descriptions__.push_back(PhysicsConfig::AbstractParamDescriptionConstPtr(new PhysicsConfig::ParamDescription<double>("gravity_z", "double", 1, "Simulated gravity in the z direction.", "", &PhysicsConfig::gravity_z)));
//#line 49 "../cfg/Physics.cfg"
      __min__.auto_disable_bodies = 0;
//#line 49 "../cfg/Physics.cfg"
      __max__.auto_disable_bodies = 1;
//#line 49 "../cfg/Physics.cfg"
      __default__.auto_disable_bodies = 0;
//#line 49 "../cfg/Physics.cfg"
      __param_descriptions__.push_back(PhysicsConfig::AbstractParamDescriptionConstPtr(new PhysicsConfig::ParamDescription<bool>("auto_disable_bodies", "bool", 1, "Auto disable of bodies in simulation if body it's not moving.", "", &PhysicsConfig::auto_disable_bodies)));
//#line 50 "../cfg/Physics.cfg"
      __min__.sor_pgs_precon_iters = 0;
//#line 50 "../cfg/Physics.cfg"
      __max__.sor_pgs_precon_iters = 10000;
//#line 50 "../cfg/Physics.cfg"
      __default__.sor_pgs_precon_iters = 0;
//#line 50 "../cfg/Physics.cfg"
      __param_descriptions__.push_back(PhysicsConfig::AbstractParamDescriptionConstPtr(new PhysicsConfig::ParamDescription<int>("sor_pgs_precon_iters", "int", 1, "Number of preconditioning iterations for SOR PGS LCP as implemented in quickstep.", "", &PhysicsConfig::sor_pgs_precon_iters)));
//#line 51 "../cfg/Physics.cfg"
      __min__.sor_pgs_iters = 0;
//#line 51 "../cfg/Physics.cfg"
      __max__.sor_pgs_iters = 10000;
//#line 51 "../cfg/Physics.cfg"
      __default__.sor_pgs_iters = 20;
//#line 51 "../cfg/Physics.cfg"
      __param_descriptions__.push_back(PhysicsConfig::AbstractParamDescriptionConstPtr(new PhysicsConfig::ParamDescription<int>("sor_pgs_iters", "int", 1, "Number of iterations for SOR PGS LCP as implemented in quickstep.", "", &PhysicsConfig::sor_pgs_iters)));
//#line 52 "../cfg/Physics.cfg"
      __min__.sor_pgs_w = 0.0;
//#line 52 "../cfg/Physics.cfg"
      __max__.sor_pgs_w = 5.0;
//#line 52 "../cfg/Physics.cfg"
      __default__.sor_pgs_w = 1.3;
//#line 52 "../cfg/Physics.cfg"
      __param_descriptions__.push_back(PhysicsConfig::AbstractParamDescriptionConstPtr(new PhysicsConfig::ParamDescription<double>("sor_pgs_w", "double", 1, "Relaxation parameter for SOR PGS LCP, usually set to 1.3, but reduce to stabilize simulation.", "", &PhysicsConfig::sor_pgs_w)));
//#line 53 "../cfg/Physics.cfg"
      __min__.sor_pgs_rms_error_tol = -1.0;
//#line 53 "../cfg/Physics.cfg"
      __max__.sor_pgs_rms_error_tol = 10000.0;
//#line 53 "../cfg/Physics.cfg"
      __default__.sor_pgs_rms_error_tol = -1.0;
//#line 53 "../cfg/Physics.cfg"
      __param_descriptions__.push_back(PhysicsConfig::AbstractParamDescriptionConstPtr(new PhysicsConfig::ParamDescription<double>("sor_pgs_rms_error_tol", "double", 1, "The number of scans to skip between each measured scan", "", &PhysicsConfig::sor_pgs_rms_error_tol)));
//#line 54 "../cfg/Physics.cfg"
      __min__.cfm = 0.0;
//#line 54 "../cfg/Physics.cfg"
      __max__.cfm = 10.0;
//#line 54 "../cfg/Physics.cfg"
      __default__.cfm = 0.0;
//#line 54 "../cfg/Physics.cfg"
      __param_descriptions__.push_back(PhysicsConfig::AbstractParamDescriptionConstPtr(new PhysicsConfig::ParamDescription<double>("cfm", "double", 1, "Constraint Force Mixing per ODE's users manual.", "", &PhysicsConfig::cfm)));
//#line 55 "../cfg/Physics.cfg"
      __min__.erp = 0.0;
//#line 55 "../cfg/Physics.cfg"
      __max__.erp = 10.0;
//#line 55 "../cfg/Physics.cfg"
      __default__.erp = 0.2;
//#line 55 "../cfg/Physics.cfg"
      __param_descriptions__.push_back(PhysicsConfig::AbstractParamDescriptionConstPtr(new PhysicsConfig::ParamDescription<double>("erp", "double", 1, "Error Reduction Parameter per ODE's users manual.", "", &PhysicsConfig::erp)));
//#line 56 "../cfg/Physics.cfg"
      __min__.contact_surface_layer = 0.0;
//#line 56 "../cfg/Physics.cfg"
      __max__.contact_surface_layer = 10.0;
//#line 56 "../cfg/Physics.cfg"
      __default__.contact_surface_layer = 0.001;
//#line 56 "../cfg/Physics.cfg"
      __param_descriptions__.push_back(PhysicsConfig::AbstractParamDescriptionConstPtr(new PhysicsConfig::ParamDescription<double>("contact_surface_layer", "double", 1, "Margin for penetration for which restorative forces are not applied.", "", &PhysicsConfig::contact_surface_layer)));
//#line 57 "../cfg/Physics.cfg"
      __min__.contact_max_correcting_vel = 0.0;
//#line 57 "../cfg/Physics.cfg"
      __max__.contact_max_correcting_vel = 10000000.0;
//#line 57 "../cfg/Physics.cfg"
      __default__.contact_max_correcting_vel = 100.0;
//#line 57 "../cfg/Physics.cfg"
      __param_descriptions__.push_back(PhysicsConfig::AbstractParamDescriptionConstPtr(new PhysicsConfig::ParamDescription<double>("contact_max_correcting_vel", "double", 1, "Maximum contact penetration correction velocity.", "", &PhysicsConfig::contact_max_correcting_vel)));
//#line 58 "../cfg/Physics.cfg"
      __min__.max_contacts = 0;
//#line 58 "../cfg/Physics.cfg"
      __max__.max_contacts = 10000000;
//#line 58 "../cfg/Physics.cfg"
      __default__.max_contacts = 100;
//#line 58 "../cfg/Physics.cfg"
      __param_descriptions__.push_back(PhysicsConfig::AbstractParamDescriptionConstPtr(new PhysicsConfig::ParamDescription<int>("max_contacts", "int", 1, "Maximum number of contacts between any 2 bodies.", "", &PhysicsConfig::max_contacts)));
//#line 239 "/opt/ros/electric/stacks/driver_common/dynamic_reconfigure/templates/ConfigType.h"
    
      for (std::vector<PhysicsConfig::AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        __description_message__.parameters.push_back(**i);
      __max__.__toMessage__(__description_message__.max, __param_descriptions__); 
      __min__.__toMessage__(__description_message__.min, __param_descriptions__); 
      __default__.__toMessage__(__description_message__.dflt, __param_descriptions__); 
    }
    std::vector<PhysicsConfig::AbstractParamDescriptionConstPtr> __param_descriptions__;
    PhysicsConfig __max__;
    PhysicsConfig __min__;
    PhysicsConfig __default__;
    dynamic_reconfigure::ConfigDescription __description_message__;
    static const PhysicsConfigStatics *get_instance()
    {
      // Split this off in a separate function because I know that
      // instance will get initialized the first time get_instance is
      // called, and I am guaranteeing that get_instance gets called at
      // most once.
      static PhysicsConfigStatics instance;
      return &instance;
    }
  };

  inline const dynamic_reconfigure::ConfigDescription &PhysicsConfig::__getDescriptionMessage__() 
  {
    return __get_statics__()->__description_message__;
  }

  inline const PhysicsConfig &PhysicsConfig::__getDefault__()
  {
    return __get_statics__()->__default__;
  }
  
  inline const PhysicsConfig &PhysicsConfig::__getMax__()
  {
    return __get_statics__()->__max__;
  }
  
  inline const PhysicsConfig &PhysicsConfig::__getMin__()
  {
    return __get_statics__()->__min__;
  }
  
  inline const std::vector<PhysicsConfig::AbstractParamDescriptionConstPtr> &PhysicsConfig::__getParamDescriptions__()
  {
    return __get_statics__()->__param_descriptions__;
  }

  inline const PhysicsConfigStatics *PhysicsConfig::__get_statics__()
  {
    const static PhysicsConfigStatics *statics;
  
    if (statics) // Common case
      return statics;

    boost::mutex::scoped_lock lock(dynamic_reconfigure::__init_mutex__);

    if (statics) // In case we lost a race.
      return statics;

    statics = PhysicsConfigStatics::get_instance();
    
    return statics;
  }


}

#endif // __PHYSICSRECONFIGURATOR_H__
