#! /usr/bin/env python
# Wrappers around the services provided by rosified gazebo

import roslib; roslib.load_manifest('gazebo')

import sys
import rospy
import os

from gazebo_msgs.msg import *
from gazebo_msgs.srv import *
from geometry_msgs.msg import Point, Pose, Quaternion, Twist, Wrench


def spawn_gazebo_model_client(model_name,model_xml,robot_namespace,initial_pose,reference_frame):
    rospy.loginfo("waiting for service spawn_gazebo_model")
    rospy.wait_for_service('/gazebo/spawn_gazebo_model')
    try:
      spawn_gazebo_model = rospy.ServiceProxy('/gazebo/spawn_gazebo_model',SpawnModel)
      resp = spawn_gazebo_model(model_name,model_xml,robot_namespace,initial_pose,reference_frame)
      rospy.loginfo("spawn status: %s",resp.status_message)
      return resp.success
    except rospy.ServiceException, e:
      rospy.logerr("Service call failed: %s",e)

def spawn_urdf_model_client(model_name,model_xml,robot_namespace,initial_pose,reference_frame):
    rospy.loginfo("waiting for service spawn_urdf_model")
    rospy.wait_for_service('/gazebo/spawn_urdf_model')
    try:
      spawn_urdf_model = rospy.ServiceProxy('/gazebo/spawn_urdf_model',SpawnModel)
      resp = spawn_urdf_model(model_name,model_xml,robot_namespace,initial_pose,reference_frame)
      rospy.loginfo("spawn status: %s",resp.status_message)
      return resp.success
    except rospy.ServiceException, e:
      rospy.logerr("Service call failed: %s",e)

def set_model_configuration_client(model_name,model_param_name,joint_names,joint_positions):
    rospy.loginfo("waiting for service set_model_configuration")
    rospy.wait_for_service('/gazebo/set_model_configuration')
    try:
      set_model_configuration = rospy.ServiceProxy('/gazebo/set_model_configuration',SetModelConfiguration)
      resp = set_model_configuration(model_name,model_param_name,joint_names,joint_positions)
      rospy.loginfo("set model configuration status: %s",resp.status_message)
      return resp.success
    except rospy.ServiceException, e:
      rospy.logerr("Service call failed: %s",e)

