//#line 2 "/opt/ros/electric/stacks/driver_common/dynamic_reconfigure/templates/ConfigType.h"
// *********************************************************
// 
// File autogenerated for the gazebo_plugins package 
// by the dynamic_reconfigure package.
// Please do not edit.
// 
// ********************************************************/

/***********************************************************
 * Software License Agreement (BSD License)
 *
 *  Copyright (c) 2008, Willow Garage, Inc.
 *  All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions
 *  are met:
 *
 *   * Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 *   * Redistributions in binary form must reproduce the above
 *     copyright notice, this list of conditions and the following
 *     disclaimer in the documentation and/or other materials provided
 *     with the distribution.
 *   * Neither the name of the Willow Garage nor the names of its
 *     contributors may be used to endorse or promote products derived
 *     from this software without specific prior written permission.
 *
 *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 *  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 *  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 *  FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 *  COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 *  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 *  BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 *  LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 *  CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 *  LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 *  ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 *  POSSIBILITY OF SUCH DAMAGE.
 ***********************************************************/

// Author: Blaise Gassend


#ifndef __gazebo_plugins__CAMERASYNCHRONIZERCONFIG_H__
#define __gazebo_plugins__CAMERASYNCHRONIZERCONFIG_H__

#include <dynamic_reconfigure/config_tools.h>
#include <limits>
#include <ros/node_handle.h>
#include <dynamic_reconfigure/ConfigDescription.h>
#include <dynamic_reconfigure/ParamDescription.h>
#include <dynamic_reconfigure/config_init_mutex.h>

namespace gazebo_plugins
{
  class CameraSynchronizerConfigStatics;
  
  class CameraSynchronizerConfig
  {
  public:
    class AbstractParamDescription : public dynamic_reconfigure::ParamDescription
    {
    public:
      AbstractParamDescription(std::string n, std::string t, uint32_t l, 
          std::string d, std::string e)
      {
        name = n;
        type = t;
        level = l;
        description = d;
        edit_method = e;
      }
      
      virtual void clamp(CameraSynchronizerConfig &config, const CameraSynchronizerConfig &max, const CameraSynchronizerConfig &min) const = 0;
      virtual void calcLevel(uint32_t &level, const CameraSynchronizerConfig &config1, const CameraSynchronizerConfig &config2) const = 0;
      virtual void fromServer(const ros::NodeHandle &nh, CameraSynchronizerConfig &config) const = 0;
      virtual void toServer(const ros::NodeHandle &nh, const CameraSynchronizerConfig &config) const = 0;
      virtual bool fromMessage(const dynamic_reconfigure::Config &msg, CameraSynchronizerConfig &config) const = 0;
      virtual void toMessage(dynamic_reconfigure::Config &msg, const CameraSynchronizerConfig &config) const = 0;
    };

    typedef boost::shared_ptr<AbstractParamDescription> AbstractParamDescriptionPtr;
    typedef boost::shared_ptr<const AbstractParamDescription> AbstractParamDescriptionConstPtr;
    
    template <class T>
    class ParamDescription : public AbstractParamDescription
    {
    public:
      ParamDescription(std::string name, std::string type, uint32_t level, 
          std::string description, std::string edit_method, T CameraSynchronizerConfig::* f) :
        AbstractParamDescription(name, type, level, description, edit_method),
        field(f)
      {}

      T (CameraSynchronizerConfig::* field);

      virtual void clamp(CameraSynchronizerConfig &config, const CameraSynchronizerConfig &max, const CameraSynchronizerConfig &min) const
      {
        if (config.*field > max.*field)
          config.*field = max.*field;
        
        if (config.*field < min.*field)
          config.*field = min.*field;
      }

      virtual void calcLevel(uint32_t &comb_level, const CameraSynchronizerConfig &config1, const CameraSynchronizerConfig &config2) const
      {
        if (config1.*field != config2.*field)
          comb_level |= level;
      }

      virtual void fromServer(const ros::NodeHandle &nh, CameraSynchronizerConfig &config) const
      {
        nh.getParam(name, config.*field);
      }

      virtual void toServer(const ros::NodeHandle &nh, const CameraSynchronizerConfig &config) const
      {
        nh.setParam(name, config.*field);
      }

      virtual bool fromMessage(const dynamic_reconfigure::Config &msg, CameraSynchronizerConfig &config) const
      {
        return dynamic_reconfigure::ConfigTools::getParameter(msg, name, config.*field);
      }

      virtual void toMessage(dynamic_reconfigure::Config &msg, const CameraSynchronizerConfig &config) const
      {
        dynamic_reconfigure::ConfigTools::appendParameter(msg, name, config.*field);
      }
    };

//#line 70 "../cfg/CameraSynchronizer.cfg"
      double projector_rate;
//#line 71 "../cfg/CameraSynchronizer.cfg"
      double projector_pulse_length;
//#line 72 "../cfg/CameraSynchronizer.cfg"
      double projector_pulse_shift;
//#line 73 "../cfg/CameraSynchronizer.cfg"
      int projector_mode;
//#line 74 "../cfg/CameraSynchronizer.cfg"
      bool prosilica_projector_inhibit;
//#line 76 "../cfg/CameraSynchronizer.cfg"
      double stereo_rate;
//#line 78 "../cfg/CameraSynchronizer.cfg"
      int wide_stereo_trig_mode;
//#line 79 "../cfg/CameraSynchronizer.cfg"
      int narrow_stereo_trig_mode;
//#line 81 "../cfg/CameraSynchronizer.cfg"
      double forearm_r_rate;
//#line 82 "../cfg/CameraSynchronizer.cfg"
      int forearm_r_trig_mode;
//#line 84 "../cfg/CameraSynchronizer.cfg"
      double forearm_l_rate;
//#line 85 "../cfg/CameraSynchronizer.cfg"
      int forearm_l_trig_mode;
//#line 87 "../cfg/CameraSynchronizer.cfg"
      double projector_tweak;
//#line 89 "../cfg/CameraSynchronizer.cfg"
      bool camera_reset;
//#line 138 "/opt/ros/electric/stacks/driver_common/dynamic_reconfigure/templates/ConfigType.h"

    bool __fromMessage__(dynamic_reconfigure::Config &msg)
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      int count = 0;
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        if ((*i)->fromMessage(msg, *this))
          count++;
      if (count != dynamic_reconfigure::ConfigTools::size(msg))
      {
        ROS_ERROR("CameraSynchronizerConfig::__fromMessage__ called with an unexpected parameter.");
        ROS_ERROR("Booleans:");
        for (unsigned int i = 0; i < msg.bools.size(); i++)
          ROS_ERROR("  %s", msg.bools[i].name.c_str());
        ROS_ERROR("Integers:");
        for (unsigned int i = 0; i < msg.ints.size(); i++)
          ROS_ERROR("  %s", msg.ints[i].name.c_str());
        ROS_ERROR("Doubles:");
        for (unsigned int i = 0; i < msg.doubles.size(); i++)
          ROS_ERROR("  %s", msg.doubles[i].name.c_str());
        ROS_ERROR("Strings:");
        for (unsigned int i = 0; i < msg.strs.size(); i++)
          ROS_ERROR("  %s", msg.strs[i].name.c_str());
        // @todo Check that there are no duplicates. Make this error more
        // explicit.
        return false;
      }
      return true;
    }

    // This version of __toMessage__ is used during initialization of
    // statics when __getParamDescriptions__ can't be called yet.
    void __toMessage__(dynamic_reconfigure::Config &msg, const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__) const
    {
      dynamic_reconfigure::ConfigTools::clear(msg);
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        (*i)->toMessage(msg, *this);
    }
    
    void __toMessage__(dynamic_reconfigure::Config &msg) const
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      __toMessage__(msg, __param_descriptions__);
    }
    
    void __toServer__(const ros::NodeHandle &nh) const
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        (*i)->toServer(nh, *this);
    }

    void __fromServer__(const ros::NodeHandle &nh)
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        (*i)->fromServer(nh, *this);
    }

    void __clamp__()
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      const CameraSynchronizerConfig &__max__ = __getMax__();
      const CameraSynchronizerConfig &__min__ = __getMin__();
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        (*i)->clamp(*this, __max__, __min__);
    }

    uint32_t __level__(const CameraSynchronizerConfig &config) const
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      uint32_t level = 0;
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        (*i)->calcLevel(level, config, *this);
      return level;
    }
    
    static const dynamic_reconfigure::ConfigDescription &__getDescriptionMessage__();
    static const CameraSynchronizerConfig &__getDefault__();
    static const CameraSynchronizerConfig &__getMax__();
    static const CameraSynchronizerConfig &__getMin__();
    static const std::vector<AbstractParamDescriptionConstPtr> &__getParamDescriptions__();
    
  private:
    static const CameraSynchronizerConfigStatics *__get_statics__();
  };
  
  template <> // Max and min are ignored for strings.
  inline void CameraSynchronizerConfig::ParamDescription<std::string>::clamp(CameraSynchronizerConfig &config, const CameraSynchronizerConfig &max, const CameraSynchronizerConfig &min) const
  {
    return;
  }

  class CameraSynchronizerConfigStatics
  {
    friend class CameraSynchronizerConfig;
    
    CameraSynchronizerConfigStatics()
    {
//#line 70 "../cfg/CameraSynchronizer.cfg"
      __min__.projector_rate = 40.0;
//#line 70 "../cfg/CameraSynchronizer.cfg"
      __max__.projector_rate = 120.0;
//#line 70 "../cfg/CameraSynchronizer.cfg"
      __default__.projector_rate = 60.0;
//#line 70 "../cfg/CameraSynchronizer.cfg"
      __param_descriptions__.push_back(CameraSynchronizerConfig::AbstractParamDescriptionConstPtr(new CameraSynchronizerConfig::ParamDescription<double>("projector_rate", "double", 31, "Projector pulse frequency in Hz.", "", &CameraSynchronizerConfig::projector_rate)));
//#line 71 "../cfg/CameraSynchronizer.cfg"
      __min__.projector_pulse_length = 0.001;
//#line 71 "../cfg/CameraSynchronizer.cfg"
      __max__.projector_pulse_length = 0.002;
//#line 71 "../cfg/CameraSynchronizer.cfg"
      __default__.projector_pulse_length = 0.002;
//#line 71 "../cfg/CameraSynchronizer.cfg"
      __param_descriptions__.push_back(CameraSynchronizerConfig::AbstractParamDescriptionConstPtr(new CameraSynchronizerConfig::ParamDescription<double>("projector_pulse_length", "double", 31, "Length of the projector pulses in s. At high currents the hardware may limit the pulse length.", "", &CameraSynchronizerConfig::projector_pulse_length)));
//#line 72 "../cfg/CameraSynchronizer.cfg"
      __min__.projector_pulse_shift = 0.0;
//#line 72 "../cfg/CameraSynchronizer.cfg"
      __max__.projector_pulse_shift = 1.0;
//#line 72 "../cfg/CameraSynchronizer.cfg"
      __default__.projector_pulse_shift = 0.0;
//#line 72 "../cfg/CameraSynchronizer.cfg"
      __param_descriptions__.push_back(CameraSynchronizerConfig::AbstractParamDescriptionConstPtr(new CameraSynchronizerConfig::ParamDescription<double>("projector_pulse_shift", "double", 31, "How far off-center the intermediate projector pulses are. Zero is on-center, one is touching the following pulse.", "", &CameraSynchronizerConfig::projector_pulse_shift)));
//#line 73 "../cfg/CameraSynchronizer.cfg"
      __min__.projector_mode = 1;
//#line 73 "../cfg/CameraSynchronizer.cfg"
      __max__.projector_mode = 3;
//#line 73 "../cfg/CameraSynchronizer.cfg"
      __default__.projector_mode = 2;
//#line 73 "../cfg/CameraSynchronizer.cfg"
      __param_descriptions__.push_back(CameraSynchronizerConfig::AbstractParamDescriptionConstPtr(new CameraSynchronizerConfig::ParamDescription<int>("projector_mode", "int", 31, "Indicates whether the projector should be off, on when in use or on all the time.", "{'enum_description': 'The projectors operating mode.', 'enum': [{'srcline': 55, 'description': 'The projector is always off.', 'srcfile': '../cfg/CameraSynchronizer.cfg', 'cconsttype': 'const int', 'value': 1, 'ctype': 'int', 'type': 'int', 'name': 'ProjectorOff'}, {'srcline': 56, 'description': 'The projector is on if one of the cameras is using it.', 'srcfile': '../cfg/CameraSynchronizer.cfg', 'cconsttype': 'const int', 'value': 2, 'ctype': 'int', 'type': 'int', 'name': 'ProjectorAuto'}, {'srcline': 57, 'description': 'The projector is always on.', 'srcfile': '../cfg/CameraSynchronizer.cfg', 'cconsttype': 'const int', 'value': 3, 'ctype': 'int', 'type': 'int', 'name': 'ProjectorOn'}]}", &CameraSynchronizerConfig::projector_mode)));
//#line 74 "../cfg/CameraSynchronizer.cfg"
      __min__.prosilica_projector_inhibit = 0;
//#line 74 "../cfg/CameraSynchronizer.cfg"
      __max__.prosilica_projector_inhibit = 1;
//#line 74 "../cfg/CameraSynchronizer.cfg"
      __default__.prosilica_projector_inhibit = 0;
//#line 74 "../cfg/CameraSynchronizer.cfg"
      __param_descriptions__.push_back(CameraSynchronizerConfig::AbstractParamDescriptionConstPtr(new CameraSynchronizerConfig::ParamDescription<bool>("prosilica_projector_inhibit", "bool", 16, "Indicates if the projector should turn off when the prosilica camera is exposing.", "", &CameraSynchronizerConfig::prosilica_projector_inhibit)));
//#line 76 "../cfg/CameraSynchronizer.cfg"
      __min__.stereo_rate = 1.0;
//#line 76 "../cfg/CameraSynchronizer.cfg"
      __max__.stereo_rate = 60.0;
//#line 76 "../cfg/CameraSynchronizer.cfg"
      __default__.stereo_rate = 30.0;
//#line 76 "../cfg/CameraSynchronizer.cfg"
      __param_descriptions__.push_back(CameraSynchronizerConfig::AbstractParamDescriptionConstPtr(new CameraSynchronizerConfig::ParamDescription<double>("stereo_rate", "double", 3, "Indicates the frame rate for both stereo cameras in Hz. (Gets rounded to suitable divisors of projector_rate.)", "", &CameraSynchronizerConfig::stereo_rate)));
//#line 78 "../cfg/CameraSynchronizer.cfg"
      __min__.wide_stereo_trig_mode = 2;
//#line 78 "../cfg/CameraSynchronizer.cfg"
      __max__.wide_stereo_trig_mode = 4;
//#line 78 "../cfg/CameraSynchronizer.cfg"
      __default__.wide_stereo_trig_mode = 4;
//#line 78 "../cfg/CameraSynchronizer.cfg"
      __param_descriptions__.push_back(CameraSynchronizerConfig::AbstractParamDescriptionConstPtr(new CameraSynchronizerConfig::ParamDescription<int>("wide_stereo_trig_mode", "int", 3, "Indicates the triggering mode of the wide stereo camera.", "{'enum_description': 'The triggering mode for the wide camera.', 'enum': [{'srcline': 61, 'description': 'The cameras frequency can be set independently of the projector frequency. There is no deterministic phase relation between projector firing and camera triggering.', 'srcfile': '../cfg/CameraSynchronizer.cfg', 'cconsttype': 'const int', 'value': 2, 'ctype': 'int', 'type': 'int', 'name': 'IgnoreProjector'}, {'srcline': 62, 'description': 'The camera always exposes while the projector is on.', 'srcfile': '../cfg/CameraSynchronizer.cfg', 'cconsttype': 'const int', 'value': 3, 'ctype': 'int', 'type': 'int', 'name': 'WithProjector'}, {'srcline': 63, 'description': 'The camera always exposes while the projector is off.', 'srcfile': '../cfg/CameraSynchronizer.cfg', 'cconsttype': 'const int', 'value': 4, 'ctype': 'int', 'type': 'int', 'name': 'WithoutProjector'}]}", &CameraSynchronizerConfig::wide_stereo_trig_mode)));
//#line 79 "../cfg/CameraSynchronizer.cfg"
      __min__.narrow_stereo_trig_mode = 2;
//#line 79 "../cfg/CameraSynchronizer.cfg"
      __max__.narrow_stereo_trig_mode = 5;
//#line 79 "../cfg/CameraSynchronizer.cfg"
      __default__.narrow_stereo_trig_mode = 4;
//#line 79 "../cfg/CameraSynchronizer.cfg"
      __param_descriptions__.push_back(CameraSynchronizerConfig::AbstractParamDescriptionConstPtr(new CameraSynchronizerConfig::ParamDescription<int>("narrow_stereo_trig_mode", "int", 3, "Indicates the triggering mode of the narrow stereo camera.", "{'enum_description': 'The triggering mode for the narrow camera.', 'enum': [{'srcline': 61, 'description': 'The cameras frequency can be set independently of the projector frequency. There is no deterministic phase relation between projector firing and camera triggering.', 'srcfile': '../cfg/CameraSynchronizer.cfg', 'cconsttype': 'const int', 'value': 2, 'ctype': 'int', 'type': 'int', 'name': 'IgnoreProjector'}, {'srcline': 62, 'description': 'The camera always exposes while the projector is on.', 'srcfile': '../cfg/CameraSynchronizer.cfg', 'cconsttype': 'const int', 'value': 3, 'ctype': 'int', 'type': 'int', 'name': 'WithProjector'}, {'srcline': 63, 'description': 'The camera always exposes while the projector is off.', 'srcfile': '../cfg/CameraSynchronizer.cfg', 'cconsttype': 'const int', 'value': 4, 'ctype': 'int', 'type': 'int', 'name': 'WithoutProjector'}, {'srcline': 64, 'description': 'The camera alternates between frames with and without the projector.', 'srcfile': '../cfg/CameraSynchronizer.cfg', 'cconsttype': 'const int', 'value': 5, 'ctype': 'int', 'type': 'int', 'name': 'AlternateProjector'}]}", &CameraSynchronizerConfig::narrow_stereo_trig_mode)));
//#line 81 "../cfg/CameraSynchronizer.cfg"
      __min__.forearm_r_rate = 1.0;
//#line 81 "../cfg/CameraSynchronizer.cfg"
      __max__.forearm_r_rate = 60.0;
//#line 81 "../cfg/CameraSynchronizer.cfg"
      __default__.forearm_r_rate = 30.0;
//#line 81 "../cfg/CameraSynchronizer.cfg"
      __param_descriptions__.push_back(CameraSynchronizerConfig::AbstractParamDescriptionConstPtr(new CameraSynchronizerConfig::ParamDescription<double>("forearm_r_rate", "double", 4, "Indicates the frame rate for the right forearm camera in Hz. (Gets rounded to suitable divisors of projector_rate.)", "", &CameraSynchronizerConfig::forearm_r_rate)));
//#line 82 "../cfg/CameraSynchronizer.cfg"
      __min__.forearm_r_trig_mode = 1;
//#line 82 "../cfg/CameraSynchronizer.cfg"
      __max__.forearm_r_trig_mode = 4;
//#line 82 "../cfg/CameraSynchronizer.cfg"
      __default__.forearm_r_trig_mode = 1;
//#line 82 "../cfg/CameraSynchronizer.cfg"
      __param_descriptions__.push_back(CameraSynchronizerConfig::AbstractParamDescriptionConstPtr(new CameraSynchronizerConfig::ParamDescription<int>("forearm_r_trig_mode", "int", 4, "Indicates the triggering mode of the right forearm camera.", "{'enum_description': 'The triggering mode for a forearm camera.', 'enum': [{'srcline': 60, 'description': 'The camera does not use the trigger input.', 'srcfile': '../cfg/CameraSynchronizer.cfg', 'cconsttype': 'const int', 'value': 1, 'ctype': 'int', 'type': 'int', 'name': 'InternalTrigger'}, {'srcline': 61, 'description': 'The cameras frequency can be set independently of the projector frequency. There is no deterministic phase relation between projector firing and camera triggering.', 'srcfile': '../cfg/CameraSynchronizer.cfg', 'cconsttype': 'const int', 'value': 2, 'ctype': 'int', 'type': 'int', 'name': 'IgnoreProjector'}, {'srcline': 62, 'description': 'The camera always exposes while the projector is on.', 'srcfile': '../cfg/CameraSynchronizer.cfg', 'cconsttype': 'const int', 'value': 3, 'ctype': 'int', 'type': 'int', 'name': 'WithProjector'}, {'srcline': 63, 'description': 'The camera always exposes while the projector is off.', 'srcfile': '../cfg/CameraSynchronizer.cfg', 'cconsttype': 'const int', 'value': 4, 'ctype': 'int', 'type': 'int', 'name': 'WithoutProjector'}]}", &CameraSynchronizerConfig::forearm_r_trig_mode)));
//#line 84 "../cfg/CameraSynchronizer.cfg"
      __min__.forearm_l_rate = 1.0;
//#line 84 "../cfg/CameraSynchronizer.cfg"
      __max__.forearm_l_rate = 60.0;
//#line 84 "../cfg/CameraSynchronizer.cfg"
      __default__.forearm_l_rate = 30.0;
//#line 84 "../cfg/CameraSynchronizer.cfg"
      __param_descriptions__.push_back(CameraSynchronizerConfig::AbstractParamDescriptionConstPtr(new CameraSynchronizerConfig::ParamDescription<double>("forearm_l_rate", "double", 8, "Indicates the frame rate for the left forearm camera in Hz. (Gets rounded to suitable divisors of projector_rate.)", "", &CameraSynchronizerConfig::forearm_l_rate)));
//#line 85 "../cfg/CameraSynchronizer.cfg"
      __min__.forearm_l_trig_mode = 1;
//#line 85 "../cfg/CameraSynchronizer.cfg"
      __max__.forearm_l_trig_mode = 4;
//#line 85 "../cfg/CameraSynchronizer.cfg"
      __default__.forearm_l_trig_mode = 1;
//#line 85 "../cfg/CameraSynchronizer.cfg"
      __param_descriptions__.push_back(CameraSynchronizerConfig::AbstractParamDescriptionConstPtr(new CameraSynchronizerConfig::ParamDescription<int>("forearm_l_trig_mode", "int", 8, "Indicates the triggering mode of the left forearm camera.", "{'enum_description': 'The triggering mode for a forearm camera.', 'enum': [{'srcline': 60, 'description': 'The camera does not use the trigger input.', 'srcfile': '../cfg/CameraSynchronizer.cfg', 'cconsttype': 'const int', 'value': 1, 'ctype': 'int', 'type': 'int', 'name': 'InternalTrigger'}, {'srcline': 61, 'description': 'The cameras frequency can be set independently of the projector frequency. There is no deterministic phase relation between projector firing and camera triggering.', 'srcfile': '../cfg/CameraSynchronizer.cfg', 'cconsttype': 'const int', 'value': 2, 'ctype': 'int', 'type': 'int', 'name': 'IgnoreProjector'}, {'srcline': 62, 'description': 'The camera always exposes while the projector is on.', 'srcfile': '../cfg/CameraSynchronizer.cfg', 'cconsttype': 'const int', 'value': 3, 'ctype': 'int', 'type': 'int', 'name': 'WithProjector'}, {'srcline': 63, 'description': 'The camera always exposes while the projector is off.', 'srcfile': '../cfg/CameraSynchronizer.cfg', 'cconsttype': 'const int', 'value': 4, 'ctype': 'int', 'type': 'int', 'name': 'WithoutProjector'}]}", &CameraSynchronizerConfig::forearm_l_trig_mode)));
//#line 87 "../cfg/CameraSynchronizer.cfg"
      __min__.projector_tweak = -0.1;
//#line 87 "../cfg/CameraSynchronizer.cfg"
      __max__.projector_tweak = 0.1;
//#line 87 "../cfg/CameraSynchronizer.cfg"
      __default__.projector_tweak = 0.0;
//#line 87 "../cfg/CameraSynchronizer.cfg"
      __param_descriptions__.push_back(CameraSynchronizerConfig::AbstractParamDescriptionConstPtr(new CameraSynchronizerConfig::ParamDescription<double>("projector_tweak", "double", 31, "Adds a time shift in seconds to the projector timing. Useful for debugging but not in normal use.", "", &CameraSynchronizerConfig::projector_tweak)));
//#line 89 "../cfg/CameraSynchronizer.cfg"
      __min__.camera_reset = 0;
//#line 89 "../cfg/CameraSynchronizer.cfg"
      __max__.camera_reset = 1;
//#line 89 "../cfg/CameraSynchronizer.cfg"
      __default__.camera_reset = 0;
//#line 89 "../cfg/CameraSynchronizer.cfg"
      __param_descriptions__.push_back(CameraSynchronizerConfig::AbstractParamDescriptionConstPtr(new CameraSynchronizerConfig::ParamDescription<bool>("camera_reset", "bool", 31, "Does a hard reset of all the cameras using a long pulse on the trigger line. This parameter resets itself to false after 3 to 4 seconds.", "", &CameraSynchronizerConfig::camera_reset)));
//#line 239 "/opt/ros/electric/stacks/driver_common/dynamic_reconfigure/templates/ConfigType.h"
    
      for (std::vector<CameraSynchronizerConfig::AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        __description_message__.parameters.push_back(**i);
      __max__.__toMessage__(__description_message__.max, __param_descriptions__); 
      __min__.__toMessage__(__description_message__.min, __param_descriptions__); 
      __default__.__toMessage__(__description_message__.dflt, __param_descriptions__); 
    }
    std::vector<CameraSynchronizerConfig::AbstractParamDescriptionConstPtr> __param_descriptions__;
    CameraSynchronizerConfig __max__;
    CameraSynchronizerConfig __min__;
    CameraSynchronizerConfig __default__;
    dynamic_reconfigure::ConfigDescription __description_message__;
    static const CameraSynchronizerConfigStatics *get_instance()
    {
      // Split this off in a separate function because I know that
      // instance will get initialized the first time get_instance is
      // called, and I am guaranteeing that get_instance gets called at
      // most once.
      static CameraSynchronizerConfigStatics instance;
      return &instance;
    }
  };

  inline const dynamic_reconfigure::ConfigDescription &CameraSynchronizerConfig::__getDescriptionMessage__() 
  {
    return __get_statics__()->__description_message__;
  }

  inline const CameraSynchronizerConfig &CameraSynchronizerConfig::__getDefault__()
  {
    return __get_statics__()->__default__;
  }
  
  inline const CameraSynchronizerConfig &CameraSynchronizerConfig::__getMax__()
  {
    return __get_statics__()->__max__;
  }
  
  inline const CameraSynchronizerConfig &CameraSynchronizerConfig::__getMin__()
  {
    return __get_statics__()->__min__;
  }
  
  inline const std::vector<CameraSynchronizerConfig::AbstractParamDescriptionConstPtr> &CameraSynchronizerConfig::__getParamDescriptions__()
  {
    return __get_statics__()->__param_descriptions__;
  }

  inline const CameraSynchronizerConfigStatics *CameraSynchronizerConfig::__get_statics__()
  {
    const static CameraSynchronizerConfigStatics *statics;
  
    if (statics) // Common case
      return statics;

    boost::mutex::scoped_lock lock(dynamic_reconfigure::__init_mutex__);

    if (statics) // In case we lost a race.
      return statics;

    statics = CameraSynchronizerConfigStatics::get_instance();
    
    return statics;
  }

//#line 55 "../cfg/CameraSynchronizer.cfg"
      const int CameraSynchronizer_ProjectorOff = 1;
//#line 56 "../cfg/CameraSynchronizer.cfg"
      const int CameraSynchronizer_ProjectorAuto = 2;
//#line 57 "../cfg/CameraSynchronizer.cfg"
      const int CameraSynchronizer_ProjectorOn = 3;
//#line 60 "../cfg/CameraSynchronizer.cfg"
      const int CameraSynchronizer_InternalTrigger = 1;
//#line 61 "../cfg/CameraSynchronizer.cfg"
      const int CameraSynchronizer_IgnoreProjector = 2;
//#line 62 "../cfg/CameraSynchronizer.cfg"
      const int CameraSynchronizer_WithProjector = 3;
//#line 63 "../cfg/CameraSynchronizer.cfg"
      const int CameraSynchronizer_WithoutProjector = 4;
//#line 64 "../cfg/CameraSynchronizer.cfg"
      const int CameraSynchronizer_AlternateProjector = 5;
}

#endif // __CAMERASYNCHRONIZERRECONFIGURATOR_H__
